$buttonSchema: (
  'primary': (
    bgColor: $color--primary,
    borderColor: $color--primary,
    color: $color--white,
    iconColor: $color--white,
    // borderRadius: 5rem,
    borderWidth: 2px,
    padding: 0 3.2rem,
    states: (
      hover: (
        bgColor: $color--secondary,
        borderColor: $color--secondary,
        color: $color--white,
        iconColor: $color--white,
      ),
      active: (
        bgColor: $color--secondary,
        borderColor: $color--secondary,
        color: $color--white,
        iconColor: $color--white,
      ),
      disabled: (
        bgColor: $color--secondary,
        borderColor: $color--secondary,
        color: $color--white,
        iconColor: $color--white,
      ),
    ),
  ),
);

.btn {
  outline: none;
  border: none;
  text-decoration: none;
  position: relative;
  text-align: center;
  user-select: none;
  transition: all 0.2s ease-in;
  text-transform: uppercase;

  // width: min(100%, 40rem);
  height: 54px;

  display: grid;
  align-items: center;

  gap: 1.2rem;

  & > svg,
  & > img {
    height: 2.4rem;
    width: auto;
  }


  @each $btn, $schema in $buttonSchema {
    &--#{$btn} {
      background-color: map-get($schema, 'bgColor');
      box-shadow: inset
        0
        0
        0
        map-get($schema, 'borderWidth')
        map-get($schema, 'borderColor');
      color: map-get($schema, 'color');
      border-radius: map-get($schema, 'borderRadius');
      padding: map-get($schema, 'padding');

      & > svg {
        color: map-get($schema, 'iconColor');
      }

      @each $state, $stateSchema in map-get($schema, 'states') {
        &:#{$state} {
          background-color: map-get($stateSchema, 'bgColor');
          box-shadow: inset
            0
            0
            0
            map-get($schema, 'borderWidth')
            map-get($stateSchema, 'borderColor');
          color: map-get($stateSchema, 'color');
          border-radius: map-get($stateSchema, 'borderRadius');

          & > svg {
            color: map-get($stateSchema, 'iconColor');
          }
        }
      }
    }
  }
}
